/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.tool;

import android.content.ContentProviderOperation;
import android.content.ContentProviderResult;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.OperationApplicationException;
import android.database.Cursor;
import android.os.RemoteException;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.CallNote;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.ui.NotesListAdapter.AppWidgetAttribute;

import java.util.ArrayList;
import java.util.HashSet;


public class DataUtils {
    // 常量标签，用于日志输出
    public static final String TAG = "DataUtils";

    /**
     * 批量删除笔记
     *
     * @param resolver 内容解析器，用于访问内容提供者
     * @param ids      要删除的笔记ID的集合
     * @return 删除成功返回true，否则返回false
     */
    public static boolean batchDeleteNotes(ContentResolver resolver, HashSet<Long> ids) {
        // 如果ID集合为空，则直接返回true，表示删除成功（实际未进行删除操作）
        if (ids == null) {
            Log.d(TAG, "the ids is null");
            return true;
        }
        // 如果ID集合大小为0，也直接返回true
        if (ids.size() == 0) {
            Log.d(TAG, "no id is in the hashset");
            return true;
        }

        // 创建一个内容提供者操作列表
        ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
        // 遍历ID集合，构建删除操作
        for (long id : ids) {
            // 如果是系统根文件夹，则跳过删除操作，并输出错误日志
            if(id == Notes.ID_ROOT_FOLDER) {
                Log.e(TAG, "Don't delete system folder root");
                continue;
            }
            // 构建删除操作，并添加到操作列表
            ContentProviderOperation.Builder builder = ContentProviderOperation
                    .newDelete(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id));
            operationList.add(builder.build());
        }

        try {
            // 批量执行操作，并获取结果
            ContentProviderResult[] results = resolver.applyBatch(Notes.AUTHORITY, operationList);
            // 如果结果为空或长度为0或第一个结果为空，则认为删除失败
            if (results == null || results.length == 0 || results[0] == null) {
                Log.d(TAG, "delete notes failed, ids:" + ids.toString());
                return false;
            }
            // 删除成功
            return true;
        } catch (RemoteException e) {
            // 捕获远程异常，并输出错误日志
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        } catch (OperationApplicationException e) {
            // 捕获操作应用异常，并输出错误日志
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        }
        // 发生异常，返回false
        return false;
    }

    /**
     * 移动笔记到指定文件夹
     *
     * @param resolver    内容解析器，用于访问内容提供者
     * @param id          要移动的笔记ID
     * @param srcFolderId 源文件夹ID
     * @param desFolderId 目标文件夹ID
     */
    public static void moveNoteToFoler(ContentResolver resolver, long id, long srcFolderId, long desFolderId) {
        // 创建内容值对象，用于存储要更新的字段及其新值
        ContentValues values = new ContentValues();
        // 设置目标文件夹ID
        values.put(NoteColumns.PARENT_ID, desFolderId);
        // 设置源文件夹ID
        values.put(NoteColumns.ORIGIN_PARENT_ID, srcFolderId);
        // 设置本地修改标志为1
        values.put(NoteColumns.LOCAL_MODIFIED, 1);
        // 更新笔记信息
        resolver.update(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id), values, null, null);
    }

    /**
     * 批量移动笔记到指定文件夹
     *
     * @param resolver 内容解析器，用于访问内容提供者
     * @param ids      要移动的笔记ID集合
     * @param folderId 目标文件夹ID
     * @return 移动成功返回true，否则返回false
     */
    public static boolean batchMoveToFolder(ContentResolver resolver, HashSet<Long> ids, long folderId) {
        // 如果ID集合为空，则直接返回true，表示移动成功（实际未进行移动操作）
        if (ids == null) {
            Log.d(TAG, "the ids is null");
            return true;
        }

        // 创建一个内容提供者操作列表
        ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
        // 遍历ID集合，构建更新操作
        for (long id : ids) {
            ContentProviderOperation.Builder builder = ContentProviderOperation
                    .newUpdate(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id));
            // 设置目标文件夹ID
            builder.withValue(NoteColumns.PARENT_ID, folderId);
            // 设置本地修改标志为1
            builder.withValue(NoteColumns.LOCAL_MODIFIED, 1);
            // 将构建的操作添加到操作列表
            operationList.add(builder.build());
        }

        try {
            // 批量执行操作，并获取结果
            ContentProviderResult[] results = resolver.applyBatch(Notes.AUTHORITY, operationList);
            // 如果结果为空或长度为0或第一个结果为空，则认为移动失败
            if (results == null || results.length == 0 || results[0] == null) {
                Log.d(TAG, "delete notes failed, ids:" + ids.toString());
                return false;
            }
            // 移动成功
            return true;
        } catch (RemoteException e) {
            // 捕获远程异常，并输出错误日志
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        } catch (OperationApplicationException e) {
            // 捕获操作应用异常，并输出错误日志
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        }
        // 发生异常，返回false
        return false;
    }

    /**
     * 获取除系统文件夹外的所有文件夹数量
     *
     * @param resolver 内容解析器，用于访问内容提供者
     * @return 文件夹数量
     */
    public static int getUserFolderCount(ContentResolver resolver) {
        // 查询非系统文件夹且非垃圾文件夹的数量
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI,
                new String[] { "COUNT(*)" },
                NoteColumns.TYPE + "=? AND " + NoteColumns.PARENT_ID + "<>?",
                new String[] { String.valueOf(Notes.TYPE_FOLDER), String.valueOf(Notes.ID_TRASH_FOLER)},
                null);

        int count = 0;
        // 如果游标不为空
        if (cursor != null) {
            // 移动到结果集的第一条记录
            if (cursor.moveToFirst()) {
                try {
                    // 获取文件夹数量
                    count = cursor.getInt(0);
                } catch (IndexOutOfBoundsException e) {
                    // 捕获索引越界异常，并输出错误日志
                    Log.e(TAG, "get folder count failed:" + e.toString());
                } finally {
                    // 关闭游标
                    cursor.close();
                }
            }
        }
        // 返回文件夹数量
        return count;
    }

    /**
     * 判断笔记是否在笔记数据库中可见
     *
     * @param resolver 内容解析器，用于访问内容提供者
     * @param noteId   笔记ID
     * @param type     笔记类型
     * @return 如果笔记存在且可见，则返回true，否则返回false
     */
    public static boolean visibleInNoteDatabase(ContentResolver resolver, long noteId, int type) {
        // 查询指定ID和类型的笔记，且不在垃圾文件夹中
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId),
                null,
                NoteColumns.TYPE + "=? AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER,
                new String[] { String.valueOf(type) },
                null);

        boolean exist = false;
        // 如果游标不为空
        if (cursor != null) {
            // 如果查询结果的数量大于0，则表示笔记存在
            if (cursor.getCount() > 0) {
                exist = true;
            }
            // 关闭游标
            cursor.close();
        }
        // 返回笔记是否存在
        return exist;
    }

    /**
     * 判断笔记是否在笔记数据库中存在
     *
     * @param resolver 内容解析器，用于访问内容提供者
     * @param noteId   笔记ID
     * @return 如果笔记存在，则返回true，否则返回false
     */

    public static boolean existInNoteDatabase(ContentResolver resolver, long noteId) {
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId),
                null, null, null, null);

        boolean exist = false;
        if (cursor != null) {
            if (cursor.getCount() > 0) {
                exist = true;
            }
            cursor.close();
        }
        return exist;
    }

    public static boolean existInDataDatabase(ContentResolver resolver, long dataId) {
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_DATA_URI, dataId),
                null, null, null, null);

        boolean exist = false;
        if (cursor != null) {
            if (cursor.getCount() > 0) {
                exist = true;
            }
            cursor.close();
        }
        return exist;
    }

    public static boolean checkVisibleFolderName(ContentResolver resolver, String name) {
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI, null,
                NoteColumns.TYPE + "=" + Notes.TYPE_FOLDER +
                " AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER +
                " AND " + NoteColumns.SNIPPET + "=?",
                new String[] { name }, null);
        boolean exist = false;
        if(cursor != null) {
            if(cursor.getCount() > 0) {
                exist = true;
            }
            cursor.close();
        }
        return exist;
    }

    public static HashSet<AppWidgetAttribute> getFolderNoteWidget(ContentResolver resolver, long folderId) {
        Cursor c = resolver.query(Notes.CONTENT_NOTE_URI,
                new String[] { NoteColumns.WIDGET_ID, NoteColumns.WIDGET_TYPE },
                NoteColumns.PARENT_ID + "=?",
                new String[] { String.valueOf(folderId) },
                null);

        HashSet<AppWidgetAttribute> set = null;
        if (c != null) {
            if (c.moveToFirst()) {
                set = new HashSet<AppWidgetAttribute>();
                do {
                    try {
                        AppWidgetAttribute widget = new AppWidgetAttribute();
                        widget.widgetId = c.getInt(0);
                        widget.widgetType = c.getInt(1);
                        set.add(widget);
                    } catch (IndexOutOfBoundsException e) {
                        Log.e(TAG, e.toString());
                    }
                } while (c.moveToNext());
            }
            c.close();
        }
        return set;
    }

    public static String getCallNumberByNoteId(ContentResolver resolver, long noteId) {
        Cursor cursor = resolver.query(Notes.CONTENT_DATA_URI,
                new String [] { CallNote.PHONE_NUMBER },
                CallNote.NOTE_ID + "=? AND " + CallNote.MIME_TYPE + "=?",
                new String [] { String.valueOf(noteId), CallNote.CONTENT_ITEM_TYPE },
                null);

        if (cursor != null && cursor.moveToFirst()) {
            try {
                return cursor.getString(0);
            } catch (IndexOutOfBoundsException e) {
                Log.e(TAG, "Get call number fails " + e.toString());
            } finally {
                cursor.close();
            }
        }
        return "";
    }

    public static long getNoteIdByPhoneNumberAndCallDate(ContentResolver resolver, String phoneNumber, long callDate) {
        Cursor cursor = resolver.query(Notes.CONTENT_DATA_URI,
                new String [] { CallNote.NOTE_ID },
                CallNote.CALL_DATE + "=? AND " + CallNote.MIME_TYPE + "=? AND PHONE_NUMBERS_EQUAL("
                + CallNote.PHONE_NUMBER + ",?)",
                new String [] { String.valueOf(callDate), CallNote.CONTENT_ITEM_TYPE, phoneNumber },
                null);

        if (cursor != null) {
            if (cursor.moveToFirst()) {
                try {
                    return cursor.getLong(0);
                } catch (IndexOutOfBoundsException e) {
                    Log.e(TAG, "Get call note id fails " + e.toString());
                }
            }
            cursor.close();
        }
        return 0;
    }

    public static String getSnippetById(ContentResolver resolver, long noteId) {
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI,
                new String [] { NoteColumns.SNIPPET },
                NoteColumns.ID + "=?",
                new String [] { String.valueOf(noteId)},
                null);

        if (cursor != null) {
            String snippet = "";
            if (cursor.moveToFirst()) {
                snippet = cursor.getString(0);
            }
            cursor.close();
            return snippet;
        }
        throw new IllegalArgumentException("Note is not found with id: " + noteId);
    }

    public static String getFormattedSnippet(String snippet) {
        if (snippet != null) {
            snippet = snippet.trim();
            int index = snippet.indexOf('\n');
            if (index != -1) {
                snippet = snippet.substring(0, index);
            }
        }
        return snippet;
    }
}
